using System;
using System.IO;
using System.Xml;

namespace BTSProjectWizard
{
	/// <summary>
	/// The IBTWizardFileGen interface is implemented by types that want
	/// to generate files for a BTWizard.  Sample implementations include a static
	/// file gen (which just returns the file), and an XSLT file gen - which runs an xslt against 
	/// the file
	/// </summary>
	public interface IBTWizardFileGen
	{
        /// <summary>
        /// Allows a file generator to get initialized from configuration, and decided if it should be run  
        /// </summary>
        /// <param name="Attributes">Configuration data</param>
        /// <param name="wiz">The wizard</param>
        /// <returns>true to run, false to skip</returns>
         bool Init(XmlAttribute[] Attributes, Wizard wiz);
		 void AddFile(string path,EnvDTE.Project proj,Wizard wiz,string suggestedName);	
	}
}
